function SSD_value = SSD(lambda,Ima_def,Ima_ref,interp_scheme,opt)

s=(size(Ima_def,1)-1)/2;
[x,y]=meshgrid(-s:s);  % subset parameterized such that center is at (0,0)

  if (strcmp(opt,'1D'))  % 1D displacement, for experiments with 1D-SSD modified criterion
    lambda(1)=0; 
    if (length(lambda)>2) 
        lambda(3)=0;
        lambda(5)=0;
    end
    if (length(lambda)>6) 
        lambda(7)=0;
        lambda(9)=0;
        lambda(11)=0;
    end   
end

% compute displacement from lambda
phi_x=lambda(1)*ones(size(Ima_def));  
phi_y=lambda(2)*ones(size(Ima_def));

if (length(lambda)>2)  % affine shape functions (order=1)
    phi_x=phi_x+lambda(3)*x+lambda(5)*y;
    phi_y=phi_y+lambda(4)*x+lambda(6)*y;
end

if (length(lambda)>6)  % quadratic shape functions (order=2)
    phi_x=phi_x+lambda(7)*x.*y+lambda(9)*x.^2+lambda(11)*y.^2;
    phi_y=phi_y+lambda(8)*x.*y+lambda(10)*x.^2+lambda(12)*y.^2;
end


Ima_def_registered_interp = interp2(x,y,Ima_def,x+phi_x,y+phi_y,interp_scheme); 

Diff = Ima_ref-Ima_def_registered_interp;
Diff = Diff(3:end-2,3:end-2);  % SSD is calculated on the original window of size s
SSD_value = mean(Diff(:).^2);

return;
