function SSDtilde_output = SSDtilde(lambda,Ima_def,Ima_ref,def_x,def_y,interp_scheme,opt,kappa)

s=(size(Ima_def,1)-1)/2;
[x,y]=meshgrid(-s:s); % subset parameterized such that center is at (0,0)

if (opt=='1D') %% 1D displacement, for experiments with 1D-SSD modified criterion
    lambda(1)=0; 
    if (length(lambda)>2) 
        lambda(3)=0;
        lambda(5)=0;
    end
    if (length(lambda)>6) 
        lambda(7)=0;
        lambda(9)=0;
        lambda(11)=0;
    end   
end

% compute displacement from lambda
phi_x=lambda(1)*ones(size(Ima_def));
phi_y=lambda(2)*ones(size(Ima_def));

if (length(lambda)>2)  % affine shape functions
    phi_x=phi_x+lambda(3)*x+lambda(5)*y;
    phi_y=phi_y+lambda(4)*x+lambda(6)*y;
end

if (length(lambda)>6)  % quadratic shape functions
    phi_x=phi_x+lambda(7)*x.*y+lambda(9)*x.^2+lambda(11)*y.^2;
    phi_y=phi_y+lambda(8)*x.*y+lambda(10)*x.^2+lambda(12)*y.^2;
end


Ima_def_registered_interp = interp2(x,y,Ima_def,x+phi_x,y+phi_y,interp_scheme); 


if (opt=='2D') 
    [Ima_def_registered_x,Ima_def_registered_y]=gradient(Ima_def_registered_interp);  
    alpha=Ima_def_registered_x.^2 + Ima_def_registered_y.^2;
end

if (opt=='1D') 
    [Ima_def_registered_x,Ima_def_registered_y]=gradient(Ima_def_registered_interp);  
    alpha = Ima_def_registered_y.^2;  
end 

if (opt=='GT')
    Ima_def_registered_interp_def = interp2(x,y,Ima_def,x+def_x,y+def_y,interp_scheme); 
    [Ima_def_registered_x,Ima_def_registered_y]=gradient(Ima_def_registered_interp_def);
    Norm=sqrt((def_x-phi_x).^2+(def_y-phi_y).^2);
    alpha=((Ima_def_registered_x.*(def_x-phi_x)+Ima_def_registered_y.*(def_y-phi_y))./Norm).^2;
end

weight=1./max(alpha,kappa);
weight=weight(3:end-2,3:end-2);

Diff = Ima_ref-Ima_def_registered_interp;
Diff = Diff(3:end-2,3:end-2);
SSDtilde_output = mean(weight(:).*Diff(:).^2);

return
