function [L,G] = calculate_LandG(n,Ima_def,def_x,def_y,interp_scheme)

s=(size(Ima_def,1)-1)/2;
[x,y]=meshgrid(-s:s);

[Ima_def_x,Ima_def_y]=gradient(Ima_def);
Ima_def_registered_x = interp2(x,y,Ima_def_x,x+def_x,y+def_y,interp_scheme); 
Ima_def_registered_y = interp2(x,y,Ima_def_y,x+def_x,y+def_y,interp_scheme); 

Ima_def_registered_x=Ima_def_registered_x(3:end-2,3:end-2);
Ima_def_registered_y=Ima_def_registered_y(3:end-2,3:end-2);
def_x=def_x(3:end-2,3:end-2);
def_y=def_y(3:end-2,3:end-2);
x=x(3:end-2,3:end-2);
y=y(3:end-2,3:end-2);
numelem=numel(Ima_def_registered_x);
L=zeros(numelem,n);
G=zeros(numelem,1);

for i=1:numelem
    G(i) = [Ima_def_registered_x(i), Ima_def_registered_y(i)] * [def_x(i); def_y(i)];
end

for j=1:n
    switch j
        case 1
            phi_j=[ones(numelem,1),zeros(numelem,1)];
        case 2
            phi_j=[zeros(numelem,1), ones(numelem,1)];
        case 3
            phi_j=[x(:), zeros(numelem,1)];
        case 4
            phi_j=[zeros(numelem,1), x(:)];
        case 5
            phi_j=[y(:), zeros(numelem,1)];
        case 6
            phi_j=[zeros(numelem,1), y(:)];
        case 7
            phi_j=[x(:).*y(:), zeros(numelem,1)];     
        case 8
            phi_j=[zeros(numelem,1), x(:).*y(:)];                 
        case 9
            phi_j=[x(:).^2, zeros(numelem,1)];                 
        case 10
            phi_j=[zeros(numelem,1), x(:).^2];                 
        case 11
            phi_j=[y(:).^2, zeros(numelem,1)];                 
        case 12
            phi_j=[zeros(numelem,1), y(:).^2];                 
    end
    for i=1:numelem      
        L(i,j) = [Ima_def_registered_x(i), Ima_def_registered_y(i)] * phi_j(i,:)';
    end
end

return
